<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div *ngIf="definitionSteps">

  <div
    *ngIf="showStart"
    class="ip-workflow-step">
    <div class="d-flex flex-row w-100 align-items-center ip-workflow-step">
      <span
        class="step-idx me-2"
        [innerText]="stepMessages.START_COUNT">
      </span>

      <fa-icon
        class="me-2"
        [icon]="actionEnum.Start | actionIcon"
        [ngbTooltip]="actionEnum.Start | actionName: false"
        [fixedWidth]="true">
      </fa-icon>
      <div class="w-100">
        <span [innerText]="originDesk?.name | namePipe : commonMessages.DELETED_DESK_LABEL"></span>
      </div>
    </div>
  </div>

  <div *ngFor="let step of definitionSteps; index as i">

    <!-- Tooltip content to display for Multi-validators viewing -->
    <ng-template #multiValidatorTooltip>
      <div class="validator-restricted-list">
        <div
          *ngFor="let validator of step.validatingDesks.slice(0, maxDisplayedValidators)"
          class="tooltip-validator"
          [innerText]="validator.name | namePipe : commonMessages.DELETED_DESK_LABEL">
        </div>
        <div *ngIf="step.validatingDesks.length > maxDisplayedValidators">…</div>
      </div>
    </ng-template>

    <div class="d-flex flex-column w-100">
      <div class="d-flex flex-row w-100 align-items-center ip-workflow-step">
        <span
          class="step-idx me-2"
          [innerText]="i + getIncrement() + '.'">
        </span>

        <fa-icon
          class="me-2"
          [icon]="step.type | stepToAction | actionIcon"
          [ngbTooltip]="step.type | stepToAction | actionName: false"
          [fixedWidth]="true">
        </fa-icon>

        <div class="w-100">

          <!-- One validator && not variable desk-->

          <ng-container
            *ngIf="step.validatingDesks.length === 1 && !isVariableDesksStep(step)"
            [ngbTooltip]="multiValidatorTooltip"
            [openDelay]="300">
            <span [innerText]="step.validatingDesks[0] | genericDeskName | namePipe : commonMessages.DELETED_DESK_LABEL"></span>
          </ng-container>

          <!-- Variable desk-->

          <ng-container *ngIf="step.validatingDesks.length === 1 && isVariableDesksStep(step)">
            <app-desk-search-input
              *ngIf="allowVariableDeskEdition === true"
              [ngbTooltip]="messages.VARIABLE_DESK"
              [openDelay]="300"
              [(desks)]="desks[i]"
              [multiple]="false"
              (desksChange)="setVariableDesks(i, $event)"
              [clearable]="true"
              [genericValidatorsAvailable]="false"
              [retrieveDeskFunction]="retrieveAssociatedDesksFn">
            </app-desk-search-input>
            <span
              *ngIf="allowVariableDeskEdition === false"
              [innerText]="messages.VARIABLE_DESK">
            </span>
          </ng-container>

          <!-- Multiple validators -->

          <ng-container *ngIf="step.validatingDesks.length > 1">

            <ng-template #validatorsTooltip>
              <ng-container *ngFor="let validator of step.validatingDesks; index as validatorIndex">
                <div *ngIf="validatorIndex < 5">
                  <span [innerText]="validator.name | namePipe : commonMessages.DELETED_DESK_LABEL"></span>
                  <span *ngIf="(step.validatingDesks.length > 5) && (validatorIndex === 5)">…</span>
                </div>
                <!-- Only displaying the first 5, ignoring the rest -->
              </ng-container>
            </ng-template>

            <div class="step-title multi-validators">
              {{ (step.parallelType || 'Simple') | validationModeName }},
              <span
                class="multi-validator-clickable-text pointer"
                [ngbTooltip]="validatorsTooltip"
                [openDelay]="300"
                [tooltipClass]="'big-tooltip'"
                (click)="showValidators(step.validatingDesks)"
                [innerText]="commonMessages.getDeskNumberLabel(step.validatingDesks.length)">
              </span>
              {{ stepMessages.MULTIPLE_VALIDATOR }}
            </div>
          </ng-container>
        </div>
      </div>
      <div class="ip-step-separator"></div>
      <div class="step-validation-details"></div>
    </div>

  </div>

</div>
